using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace TestLibrary
{
    /// <summary>
    ///  Ʈ
    /// </summary>
    public partial class GaugeControl : UserControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ּ 
        /// </summary>
        private float minimumValue;

        /// <summary>
        /// ִ 
        /// </summary>
        private float maximumValue;

        /// <summary>
        /// Ӱ 
        /// </summary>
        private float thresholdPercent;

        /// <summary>
        ///  
        /// </summary>
        private float currentValue;

        /// <summary>
        /// õ 
        /// </summary>
        private float recommendedValue;

        /// <summary>
        ///   īƮ
        /// </summary>
        private int majorDivisionCount;

        /// <summary>
        ///   īƮ
        /// </summary>
        private int minorDivisionCount;

        /// <summary>
        /// ̾ ؽƮ
        /// </summary>
        private string dialText;

        /// <summary>
        /// ̾ 
        /// </summary>
        private Color dialColor = Color.Lavender;

        /// <summary>
        /// ü 
        /// </summary>
        private float glossinessAlpha = 25;

        /// <summary>
        ///  ʺ
        /// </summary>
        private int previousWidth;
        
        /// <summary>
        ///  
        /// </summary>
        private int previousHeight;

        /// <summary>
        /// X ǥ
        /// </summary>
        private int x;
        
        /// <summary>
        /// Y ǥ
        /// </summary>
        private int y;
        
        /// <summary>
        /// ʺ
        /// </summary>
        private int width;
        
        /// <summary>
        /// 
        /// </summary>
        private int height;

        /// <summary>
        /// FROM 
        /// </summary>
        private float fromAngle = 135f;

        /// <summary>
        /// TO 
        /// </summary>
        private float toAngle = 405F;

        /// <summary>
        ///   Ȱȭ 
        /// </summary>
        private bool enableTransparentBackground;

        /// <summary>
        /// ٽ ׸ 䱸 
        /// </summary>
        private bool requireRedraw;

        /// <summary>
        ///  ̹
        /// </summary>
        private Image backgroundImage;

        /// <summary>
        /// ̹ 簢
        /// </summary>
        private Rectangle imageRectangle;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ּ  - MinimumValue

        /// <summary>
        /// ּ 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(0)]
        [Description("ּ  ų մϴ.")]
        public float MinimumValue
        {
            get
            {
                return this.minimumValue;
            }
            set
            {
                if(value < this.maximumValue)
                {
                    this.minimumValue = value;

                    if(this.currentValue < this.minimumValue)
                    {
                        this.currentValue = this.minimumValue;
                    }

                    if(this.recommendedValue < this.minimumValue)
                    {
                        this.recommendedValue = this.minimumValue;
                    }

                    this.requireRedraw = true;

                    Invalidate();
                }
            }
        }

        #endregion
        #region ִ  - MaximumValue

        /// <summary>
        /// ִ 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(100)]
        [Description("Maximum value on the scale")]
        public float MaximumValue
        {
            get
            {
                return this.maximumValue;
            }
            set
            {
                if(value > this.minimumValue)
                {
                    this.maximumValue = value;

                    if(this.currentValue > this.maximumValue)
                    {
                        this.currentValue = this.maximumValue;
                    }

                    if(this.recommendedValue > this.maximumValue)
                    {
                        this.recommendedValue = this.maximumValue;
                    }

                    this.requireRedraw = true;

                    Invalidate();
                }
            }
        }

        #endregion
        #region Ӱ  - ThresholdPercent

        /// <summary>
        /// Ӱ 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(25)]
        [Description("õ  Ӱ  ų մϴ. (1-99%)")]
        public float ThresholdPercent
        {
            get
            {
                return this.thresholdPercent;
            }
            set
            {
                if(value > 0 && value < 100)
                {
                    this.thresholdPercent = value;

                    this.requireRedraw = true;

                    Invalidate();
                }
            }
        }

        #endregion
        #region õ  - RecommendedValue

        /// <summary>
        /// õ 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(25)]
        [Description("  ǥ Ӱ  ų մϴ.")]
        public float RecommendedValue
        {
            get
            {
                return this.recommendedValue;
            }
            set
            {
                if(value > this.minimumValue && value < this.maximumValue) 
                {
                    this.recommendedValue = value;

                    this.requireRedraw = true;

                    Invalidate();
                }
            }
        }

        #endregion
        #region  - Value

        /// <summary>
        /// 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(0)]
        [Description("Ͱ Ű  ų մϴ.")]
        public float Value
        {
            get
            {
                return this.currentValue;
            }
            set
            {
                if(value >= this.minimumValue && value <= this.maximumValue)
                {
                    this.currentValue = value;

                    Refresh();
                }
            }
        }

        #endregion
        #region ̾  - DialColor

        /// <summary>
        /// ̾ 
        /// </summary>
        [Category("GaugeControl")]
        [Description("̾   ų մϴ.")]
        public Color DialColor
        {
            get
            {
                return this.dialColor;
            }
            set
            {
                this.dialColor = value;

                this.requireRedraw = true;

                Invalidate();
            }
        }

        #endregion
        #region  - Glossiness

        /// <summary>
        /// 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(72)]
        [Description("  ų մϴ. ( : 0-100)")]
        public float Glossiness
        {
            get
            {
                return (this.glossinessAlpha * 100) / 220;
            }
            set
            {
                float temporaryValue = value;

                if(temporaryValue > 100) 
                {
                    value = 100;
                }

                if(temporaryValue < 0)
                {
                    value = 0;
                }

                this.glossinessAlpha = (value * 220) / 100;

                Refresh();
            }
        }

        #endregion
        #region   īƮ - MajorDivisionCount

        /// <summary>
        ///   īƮ
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(10)]
        [Description("̾ Ͽ   īƮ ų մϴ.")]
        public int MajorDivisionCount
        {
            get
            {
                return this.majorDivisionCount;
            }
            set
            {
                if(value > 1 && value < 25)
                {
                    this.majorDivisionCount = value;

                    this.requireRedraw = true;

                    Invalidate();
                }
            }
        }

        #endregion
        #region   īƮ - MinorDivisionCount

        /// <summary>
        ///   īƮ
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(3)]
        [Description("     īƮ ų մϴ.")]
        public int MinorDivisionCount
        {
            get
            {
                return this.minorDivisionCount;
            }
            set
            {
                if(value > 0 && value <= 10)
                {
                    this.minorDivisionCount = value;

                    this.requireRedraw = true;

                    Invalidate();
                }
            }
        }

        #endregion
        #region ̾ ؽƮ - DialText

        /// <summary>
        /// ̾ ؽƮ
        /// </summary>
        [Category("GaugeControl")]
        [Description("̾ ǥ ؽƮ ų մϴ.")]
        public string DialText
        {
            get
            {
                return this.dialText;
            }
            set
            {
                this.dialText = value;

                this.requireRedraw = true;

                Invalidate();
            }
        }

        #endregion
        #region   Ȱȭ  - EnableTransparentBackground

        /// <summary>
        ///   Ȱȭ 
        /// </summary>
        [Category("GaugeControl")]
        [DefaultValue(false)]
        [Description("Enables or Disables Transparent Background color. Note: Enabling this will reduce the performance and may make the control flicker.")]
        public bool EnableTransparentBackground
        {
            get
            {
                return this.enableTransparentBackground;
            }
            set
            {
                this.enableTransparentBackground = value;

                SetStyle(ControlStyles.OptimizedDoubleBuffer, !this.enableTransparentBackground);

                this.requireRedraw = true;

                Refresh();  
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  Ű  - CreateParams

        /// <summary>
        ///  Ű 
        /// </summary>
        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams createParams = base.CreateParams;

                createParams.ExStyle |= 0x20;

                return createParams;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - GaugeControl()

        /// <summary>
        /// 
        /// </summary>
        public GaugeControl()
        {
            InitializeComponent();

            this.x                  = 5;
            this.y                  = 5;
            this.width              = this.Width  - 10;
            this.height             = this.Height - 10;
            this.majorDivisionCount = 10;
            this.minorDivisionCount = 3;

            SetStyle(ControlStyles.SupportsTransparentBackColor, true);
            SetStyle(ControlStyles.ResizeRedraw                , true);
            SetStyle(ControlStyles.AllPaintingInWmPaint        , true);
            SetStyle(ControlStyles.UserPaint                   , true);
            SetStyle(ControlStyles.OptimizedDoubleBuffer       , true);                     

            this.BackColor = Color.Transparent;

            Resize += UserControl_Resize;

            this.requireRedraw = true;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected
        //////////////////////////////////////////////////////////////////////////////// Function

        #region Ʈ óϱ - OnPaint(e)

        /// <summary>
        /// Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ ߻</param>
        protected override void OnPaint(PaintEventArgs e)
        {
            e.Graphics.SmoothingMode = SmoothingMode.AntiAlias;

            this.width  = Width  - this.x * 2;
            this.height = Height - this.y * 2;

            #region   ׸.

            RectangleF digitalValueRectangle1 = new RectangleF((float)Width / 2f - (float)this.width / 5f, (float)this.height / 1.2f, (float)this.width / 2.5f, (float)Height / 9f);
            RectangleF digitalValueRectangle2 = new RectangleF(Width / 2 - this.width / 7                , (int)(this.height / 1.18), this.width / 4          , this.Height / 12  );

            e.Graphics.FillRectangle(new SolidBrush(Color.FromArgb(30, Color.Gray)), digitalValueRectangle1);

            DisplayNumber(e.Graphics, this.currentValue, digitalValueRectangle2);

            SizeF textSize = e.Graphics.MeasureString(this.dialText, Font);

            RectangleF dialTextRectangle = new RectangleF(Width / 2 - textSize.Width / 2, (int)(this.height / 1.5), textSize.Width, textSize.Height);

            e.Graphics.DrawString(this.dialText, Font, new SolidBrush(ForeColor), dialTextRectangle);

            #endregion

            DrawPointer(e.Graphics, ((this.width) / 2) + this.x, ((this.height) / 2) + this.y);

        }

        #endregion
        #region  Ʈ óϱ - OnPaintBackground(e)

        /// <summary>
        ///  Ʈ óϱ
        /// </summary>
        /// <param name="e">̺Ʈ </param>
        protected override void OnPaintBackground(PaintEventArgs e)
        {
            if(!this.enableTransparentBackground)
            {
                base.OnPaintBackground(e);
            }         
            
            e.Graphics.SmoothingMode = SmoothingMode.HighQuality;

            e.Graphics.FillRectangle(new SolidBrush(Color.Transparent), new Rectangle(0, 0, Width, Height));

            if(this.backgroundImage == null || this.requireRedraw)
            {
                this.backgroundImage = new Bitmap(Width, Height);

                Graphics imageGraphics = Graphics.FromImage(this.backgroundImage);

                imageGraphics.SmoothingMode = SmoothingMode.HighQuality;

                this.width  = Width  - this.x * 2;
                this.height = Height - this.y * 2;

                this.imageRectangle = new Rectangle(this.x, this.y, this.width, this.height);

                //   ׸.
                Brush backgroundBrush = new SolidBrush(Color.FromArgb(120, this.dialColor));

                if(this.enableTransparentBackground && this.Parent != null)
                {
                    float offset = this.width / 60;

                    imageGraphics.FillEllipse(new SolidBrush(this.Parent.BackColor), -offset, -offset, Width + offset * 2, Height + offset * 2);
                }

                imageGraphics.FillEllipse(backgroundBrush, this.x, this.y, this.width, this.height);

                // ڸ ׸.
                SolidBrush outlineBrush = new SolidBrush(Color.FromArgb(100, Color.SlateGray));

                Pen outlinePen = new Pen(outlineBrush, (float)(this.width * .03));

                imageGraphics.DrawEllipse(outlinePen, this.imageRectangle);

                Pen darkRimPen = new Pen(Color.SlateGray);

                imageGraphics.DrawEllipse(darkRimPen, this.x, this.y, this.width, this.height);

                // Ķ극̼ ׸.
                DrawCalibration(imageGraphics, this.imageRectangle, ((this.width) / 2) + this.x, ((this.height) / 2) + this.y);

                //   ڸ ׸.
                Pen colorPen = new Pen(Color.FromArgb(190, Color.Gainsboro), Width / 40 );
                Pen blackPen = new Pen(Color.FromArgb(250, Color.Black    ), Width / 200);

                int gap = (int)(Width * 0.03f);

                Rectangle rectangle = new Rectangle(this.imageRectangle.X + gap, this.imageRectangle.Y + gap, this.imageRectangle.Width - gap * 2, this.imageRectangle.Height - gap * 2);

                imageGraphics.DrawArc(colorPen, rectangle, 135, 270);

                // Ӱ  ׸.
                colorPen = new Pen(Color.FromArgb(200, Color.LawnGreen), Width / 50);

                rectangle = new Rectangle(this.imageRectangle.X + gap, this.imageRectangle.Y + gap, this.imageRectangle.Width - gap * 2, this.imageRectangle.Height - gap * 2);

                float difference = MaximumValue - MinimumValue;

                difference = (100 * (this.recommendedValue - MinimumValue)) / difference;

                difference = ((this.toAngle - this.fromAngle) * difference) / 100;

                difference += this.fromAngle;

                float startAngle = difference - ((270 * this.thresholdPercent) / 200);

                if(startAngle <= 135)
                {
                    startAngle = 135;
                }

                float sweepAngle = ((270 * this.thresholdPercent) / 100);

                if(startAngle + sweepAngle > 405)
                {
                    sweepAngle = 405 - startAngle;
                }

                imageGraphics.DrawArc(colorPen, rectangle, startAngle, sweepAngle);

                //   ׸.
                //RectangleF digitalValueRectangle1 = new RectangleF((float)Width / 2f - (float)this.width / 5f, (float)this.height / 1.2f, (float)this.width / 2.5f, (float)Height / 9f);
                //RectangleF digitalValueRectangle2 = new RectangleF(Width / 2 - this.width / 7                , (int)(this.height / 1.18), this.width / 4          , this.Height / 12  );
                //
                //imageGraphics.FillRectangle(new SolidBrush(Color.FromArgb(30, Color.Gray)), digitalValueRectangle1);
                //
                //DisplayNumber(imageGraphics, this.currentValue, digitalValueRectangle2);
                //
                //SizeF textSize = imageGraphics.MeasureString(this.dialText, Font);
                //
                //RectangleF dialTextRectangle = new RectangleF(Width / 2 - textSize.Width / 2, (int)(this.height / 1.5), textSize.Width, textSize.Height);
                //
                //imageGraphics.DrawString(this.dialText, Font, new SolidBrush(ForeColor), dialTextRectangle);

                this.requireRedraw = false;
            }

            e.Graphics.DrawImage(this.backgroundImage, this.imageRectangle);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  Ʈ ũ 缳 óϱ - UserControl_Resize(sender, e)

        /// <summary>
        ///  Ʈ ũ 缳 óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void UserControl_Resize(object sender, EventArgs e)
        {
            if(Width < 136)
            {
                Width = 136;
            }

            if(this.previousWidth != Width)
            {
                Height = Width;

                this.previousHeight = Width;
            }

            if(this.previousHeight != Height)
            {
                Width = Height;

                this.previousWidth = Width;
            }

            Invalidate();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  ϱ - GetRadian(theta)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="theta">Ÿ</param>
        /// <returns></returns>
        public float GetRadian(float theta)
        {
            return theta * (float)Math.PI / 180f;
        }

        #endregion
        #region ߽ ׸ - DrawCenterPoint(graphics, sourceRectangle, width, height)

        /// <summary>
        /// ߽ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="sourceRectangle">ҽ 簢</param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        private void DrawCenterPoint(Graphics graphics, Rectangle sourceRectangle, int width, int height)
        {
            float shift = Width / 5;

            RectangleF targetRectangle = new RectangleF(width - (shift / 2), height - (shift / 2), shift, shift);

            LinearGradientBrush brush = new LinearGradientBrush(sourceRectangle, Color.Black, Color.FromArgb(100, this.dialColor), LinearGradientMode.Vertical);

            graphics.FillEllipse(brush, targetRectangle);

            shift = Width / 7;

            targetRectangle = new RectangleF(width - (shift / 2), height - (shift / 2), shift, shift);

            brush = new LinearGradientBrush(sourceRectangle, Color.SlateGray, Color.Black, LinearGradientMode.ForwardDiagonal);

            graphics.FillEllipse(brush, targetRectangle);
        }

        #endregion
        #region  ׸ - DrawGlossiness(graphics) 

        /// <summary>
        ///  ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        private void DrawGlossiness(Graphics graphics)
        {
            RectangleF glossinessRectangle = new RectangleF
            (
                this.x + (float)(this.width  * 0.10),
                this.y + (float)(this.height * 0.07),
                (float)(this.width  * 0.80),
                (float)(this.height * 0.7 )
            );

            LinearGradientBrush gradientBrush = new LinearGradientBrush
            (
                glossinessRectangle,
                Color.FromArgb((int)this.glossinessAlpha, Color.White),
                Color.Transparent,
                LinearGradientMode.Vertical
            );

            graphics.FillEllipse(gradientBrush, glossinessRectangle);

            glossinessRectangle = new RectangleF
            (
                this.x + (float)(this.width  * 0.25),
                this.y + (float)(this.height * 0.77),
                (float)(this.width  * 0.50),
                (float)(this.height * 0.2 )
            );

            int glossiness = (int)(this.glossinessAlpha / 3);

            gradientBrush = new LinearGradientBrush
            (
                glossinessRectangle,
                Color.Transparent,
                Color.FromArgb(glossiness, BackColor),
                LinearGradientMode.Vertical
            );

            graphics.FillEllipse(gradientBrush, glossinessRectangle);
        }
        
        #endregion
        #region  ׸ - DrawPointer(graphics, width, height)

        /// <summary>
        ///  ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        private void DrawPointer(Graphics graphics, int width, int height)
        {
            float radius     = Width / 2 - (Width * .12f);
            float difference = MaximumValue - MinimumValue;

            Image    image         = new Bitmap(Width, Height);
            Graphics imageGraphics = Graphics.FromImage(image);

            imageGraphics.SmoothingMode = SmoothingMode.AntiAlias;

            difference = (100 * (this.currentValue - MinimumValue)) / difference;
            difference = ((this.toAngle - this.fromAngle) * difference) / 100;

            difference += this.fromAngle;

            float angle         = GetRadian(difference);
            float gradientAngle = angle;

            PointF[] pointArray = new PointF[5];

            pointArray[0].X = (float)(width  + radius * Math.Cos(angle));
            pointArray[0].Y = (float)(height + radius * Math.Sin(angle));

            pointArray[4].X = (float)(width  + radius * Math.Cos(angle - 0.02));
            pointArray[4].Y = (float)(height + radius * Math.Sin(angle - 0.02));

            angle = GetRadian((difference + 20));

            pointArray[1].X = (float)(width  + (Width * .09f) * Math.Cos(angle));
            pointArray[1].Y = (float)(height + (Width * .09f) * Math.Sin(angle));

            pointArray[2].X = width;
            pointArray[2].Y = height;

            angle = GetRadian((difference - 20));

            pointArray[3].X = (float)(width  + (Width * .09f) * Math.Cos(angle));
            pointArray[3].Y = (float)(height + (Width * .09f) * Math.Sin(angle));

            Brush pointerBrush1 = new SolidBrush(Color.Black);

            imageGraphics.FillPolygon(pointerBrush1, pointArray);

            PointF[] shinePointArray = new PointF[3];

            angle = GetRadian(difference);

            shinePointArray[0].X = (float)(width  + radius * Math.Cos(angle));
            shinePointArray[0].Y = (float)(height + radius * Math.Sin(angle));

            angle = GetRadian(difference + 20);

            shinePointArray[1].X = (float)(width  + (Width * .09f) * Math.Cos(angle));
            shinePointArray[1].Y = (float)(height + (Width * .09f) * Math.Sin(angle));

            shinePointArray[2].X = width;
            shinePointArray[2].Y = height;

            LinearGradientBrush pointerBrush2 = new LinearGradientBrush(shinePointArray[0], shinePointArray[2], Color.SlateGray, Color.Black);

            imageGraphics.FillPolygon(pointerBrush2, shinePointArray);

            Rectangle rectangle = new Rectangle(this.x, this.y, this.width, this.height);

            DrawCenterPoint(imageGraphics, rectangle, ((this.width) / 2) + this.x, ((this.height) / 2) + this.y);

            DrawGlossiness(imageGraphics);

            graphics.DrawImage(image, 0, 0);
        }

        #endregion

        #region Ķ극̼ ׸ - DrawCalibration(graphics, sourceRectangle, width, height)

        /// <summary>
        /// Ķ극̼ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="sourceRectangle">ҽ 簢</param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        private void DrawCalibration(Graphics graphics, Rectangle sourceRectangle, int width, int height)
        {
            int       partCount         = this.majorDivisionCount + 1;
            int       intermediateCount = this.minorDivisionCount;
            float     currentAngle      = GetRadian(this.fromAngle);
            int       gap               = (int)(Width * 0.01f);
            float     shift             = Width / 25;
            Rectangle targetRectangle   = new Rectangle(sourceRectangle.Left + gap, sourceRectangle.Top + gap, sourceRectangle.Width - gap, sourceRectangle.Height - gap);
                                   
            float x1;
            float y1;
            float x2;
            float y2;
            float temporaryX;
            float temporaryY;
            float radius;

            radius = targetRectangle.Width / 2 - gap * 5;

            float totalAngle = this.toAngle - this.fromAngle;
            float increment  = GetRadian(((totalAngle) / ((partCount - 1) * (intermediateCount + 1))));
            
            Pen thickPen = new Pen(Color.Black, Width / 50 );
            Pen thinPen  = new Pen(Color.Black, Width / 100);

            float rulerValue = MinimumValue;

            for(int i = 0; i <= partCount; i++)
            {
                // β  ׸.
                x1 = (float)(width  + radius * Math.Cos(currentAngle));
                y1 = (float)(height + radius * Math.Sin(currentAngle));
                x2 = (float)(width  + (radius - Width / 20) * Math.Cos(currentAngle));
                y2 = (float)(height + (radius - Width / 20) * Math.Sin(currentAngle));

                graphics.DrawLine(thickPen, x1, y1, x2, y2);
                
                // ڿ ׸.
                temporaryX = (float)(width + (radius - Width / 10) * Math.Cos(currentAngle));
                temporaryY = (float)(height - shift + (radius - Width / 10) * Math.Sin(currentAngle));

                Brush stringPen = new SolidBrush(this.ForeColor);

                StringFormat stringFormat = new StringFormat(StringFormatFlags.NoClip);

                stringFormat.Alignment = StringAlignment.Center;

                Font font = new Font(Font.FontFamily, (float)(Width / 23), Font.Style);

                graphics.DrawString(rulerValue.ToString() + string.Empty, font, stringPen, new PointF(temporaryX, temporaryY), stringFormat);

                rulerValue += (float)((MaximumValue - MinimumValue) / (partCount - 1));
                
                rulerValue = (float)Math.Round(rulerValue, 2);
                
                if(i == partCount -1)
                {
                    break;
                }

                for(int j = 0; j <= intermediateCount; j++)
                {
                    //   ׸.
                    currentAngle += increment;

                    x1 = (float)(width  + radius * Math.Cos(currentAngle));
                    y1 = (float)(height + radius * Math.Sin(currentAngle));
                    x2 = (float)(width  + (radius - Width / 50) * Math.Cos(currentAngle));
                    y2 = (float)(height + (radius - Width / 50) * Math.Sin(currentAngle));

                    graphics.DrawLine(thinPen, x1, y1, x2, y2);                    
                }
            }
        }

        #endregion
        #region  X ϱ - GetX(x, width)

        /// <summary>
        ///  X ϱ
        /// </summary>
        /// <param name="x">X</param>
        /// <param name="width">ʺ</param>
        /// <returns> X</returns>
        private float GetX(float x, float width)
        {
            return x * width / 12;
        }

        #endregion
        #region  Y ϱ - GetY(y, height)

        /// <summary>
        ///  Y ϱ
        /// </summary>
        /// <param name="y">Y</param>
        /// <param name="height"></param>
        /// <returns> Y</returns>
        private float GetY(float y, float height)
        {
            return y * height / 15;
        }

        #endregion
        #region  ̿   ϱ - IsNumberAvailable(targetNumber, sourceNumberArray)

        /// <summary>
        ///  ̿   ϱ
        /// </summary>
        /// <param name="targetNumber">Ÿ </param>
        /// <param name="sourceNumberArray">ҽ  迭</param>
        /// <returns> ̿  </returns>
        private bool IsNumberAvailable(int targetNumber, params int[] sourceNumberArray)
        {
            if(sourceNumberArray.Length > 0)
            {
                foreach(int sourceNumber in sourceNumberArray)
                {
                    if(sourceNumber == targetNumber)
                    {
                        return true;
                    }
                }
            }

            return false;
        }

        #endregion
        #region  ׸ - DrawDigit(graphics, number, position, drawDecimalPoint, height)

        /// <summary>
        ///  ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="number"></param>
        /// <param name="position">ġ</param>
        /// <param name="drawDecimalPoint">Ҽ ׸ </param>
        /// <param name="height"></param>
        private void DrawDigit(Graphics graphics, int number, PointF position, bool drawDecimalPoint, float height)
        {
            float width;

            width = 10f * height / 13;
            
            Pen outlinePen = new Pen(Color.FromArgb(40, this.dialColor));
            Pen fillPen    = new Pen(Color.Black);

            #region ٰ Ʈ Ѵ.

            // Segment A
            PointF[] segmentAPointArray = new PointF[5];

            segmentAPointArray[0] = segmentAPointArray[4] = new PointF(position.X + GetX(2.8f, width), position.Y + GetY(1f, height));
            segmentAPointArray[1] = new PointF(position.X + GetX(10.0f, width), position.Y + GetY(1f, height));
            segmentAPointArray[2] = new PointF(position.X + GetX( 8.8f, width), position.Y + GetY(2f, height));
            segmentAPointArray[3] = new PointF(position.X + GetX( 3.8f, width), position.Y + GetY(2f, height));            

            // Segment B
            PointF[] segmentBPointArray = new PointF[5];

            segmentBPointArray[0] = segmentBPointArray[4] = new PointF(position.X + GetX(10, width), position.Y + GetY(1.4f, height));
            segmentBPointArray[1] = new PointF(position.X + GetX(9.3f, width), position.Y + GetY(6.8f, height));
            segmentBPointArray[2] = new PointF(position.X + GetX(8.4f, width), position.Y + GetY(6.4f, height));
            segmentBPointArray[3] = new PointF(position.X + GetX(9.0f, width), position.Y + GetY(2.2f, height)); 

            // Segment C
            PointF[] segmentCPointArray = new PointF[5];

            segmentCPointArray[0] = segmentCPointArray[4] = new PointF(position.X + GetX(9.2f, width), position.Y + GetY(7.2f, height));
            segmentCPointArray[1] = new PointF(position.X + GetX(8.7f, width), position.Y + GetY(12.7f, height));
            segmentCPointArray[2] = new PointF(position.X + GetX(7.6f, width), position.Y + GetY(11.9f, height));
            segmentCPointArray[3] = new PointF(position.X + GetX(8.2f, width), position.Y + GetY( 7.7f, height)); 

            // Segment D
            PointF[] segmentDPointArray = new PointF[5];

            segmentDPointArray[0] = segmentDPointArray[4] = new PointF(position.X + GetX(7.4f, width), position.Y + GetY(12.1f, height));
            segmentDPointArray[1] = new PointF(position.X + GetX(8.4f, width), position.Y + GetY(13.0f, height));
            segmentDPointArray[2] = new PointF(position.X + GetX(1.3f, width), position.Y + GetY(13.0f, height));
            segmentDPointArray[3] = new PointF(position.X + GetX(2.2f, width), position.Y + GetY(12.1f, height));

            // Segment E
            PointF[] segmentEPointArray = new PointF[5];

            segmentEPointArray[0] = segmentEPointArray[4] = new PointF(position.X + GetX(2.2f, width), position.Y + GetY(11.8f, height));
            segmentEPointArray[1] = new PointF(position.X + GetX(1.0f, width), position.Y + GetY(12.7f, height));
            segmentEPointArray[2] = new PointF(position.X + GetX(1.7f, width), position.Y + GetY( 7.2f, height));
            segmentEPointArray[3] = new PointF(position.X + GetX(2.8f, width), position.Y + GetY( 7.7f, height)); 

            // Segment F
            PointF[] segmentFPointArray = new PointF[5];

            segmentFPointArray[0] = segmentFPointArray[4] = new PointF(position.X + GetX(3f, width), position.Y + GetY(6.4f, height));
            segmentFPointArray[1] = new PointF(position.X + GetX(1.8f, width), position.Y + GetY(6.8f, height));
            segmentFPointArray[2] = new PointF(position.X + GetX(2.6f, width), position.Y + GetY(1.3f, height));
            segmentFPointArray[3] = new PointF(position.X + GetX(3.6f, width), position.Y + GetY(2.2f, height));

            // Segment G
            PointF[] segmentGPointArray = new PointF[7];

            segmentGPointArray[0] = segmentGPointArray[6] = new PointF(position.X + GetX(2f, width), position.Y + GetY(7f, height));
            segmentGPointArray[1] = new PointF(position.X + GetX(3.1f, width), position.Y + GetY(6.5f, height));
            segmentGPointArray[2] = new PointF(position.X + GetX(8.3f, width), position.Y + GetY(6.5f, height));
            segmentGPointArray[3] = new PointF(position.X + GetX(9.0f, width), position.Y + GetY(7.0f, height));
            segmentGPointArray[4] = new PointF(position.X + GetX(8.2f, width), position.Y + GetY(7.5f, height));
            segmentGPointArray[5] = new PointF(position.X + GetX(2.9f, width), position.Y + GetY(7.5f, height));

            #endregion
            #region ׸Ʈ ܰ ׸.

            graphics.FillPolygon(outlinePen.Brush, segmentAPointArray);
            graphics.FillPolygon(outlinePen.Brush, segmentBPointArray);
            graphics.FillPolygon(outlinePen.Brush, segmentCPointArray);
            graphics.FillPolygon(outlinePen.Brush, segmentDPointArray);
            graphics.FillPolygon(outlinePen.Brush, segmentEPointArray);
            graphics.FillPolygon(outlinePen.Brush, segmentFPointArray);
            graphics.FillPolygon(outlinePen.Brush, segmentGPointArray);

            #endregion
            #region ׸Ʈ ĥѴ.

            // Segment A
            if(IsNumberAvailable(number, 0, 2, 3, 5, 6, 7, 8, 9))
            {
                graphics.FillPolygon(fillPen.Brush, segmentAPointArray);
            }

            // Segment B
            if(IsNumberAvailable(number, 0, 1, 2, 3, 4, 7, 8, 9))
            {
                graphics.FillPolygon(fillPen.Brush, segmentBPointArray);
            }

            // Segment C
            if(IsNumberAvailable(number, 0, 1, 3, 4, 5, 6, 7, 8, 9))
            {
                graphics.FillPolygon(fillPen.Brush, segmentCPointArray);
            }

            // Segment D
            if(IsNumberAvailable(number, 0, 2, 3, 5, 6, 8, 9))
            {
                graphics.FillPolygon(fillPen.Brush, segmentDPointArray);
            }

            // Segment E
            if(IsNumberAvailable(number, 0, 2, 6, 8))
            {
                graphics.FillPolygon(fillPen.Brush, segmentEPointArray);
            }

            // Segment F
            if(IsNumberAvailable(number, 0, 4, 5, 6, 7, 8, 9))
            {
                graphics.FillPolygon(fillPen.Brush, segmentFPointArray);
            }

            // Segment G
            if(IsNumberAvailable(number, 2, 3, 4, 5, 6, 8, 9, -1))
            {
                graphics.FillPolygon(fillPen.Brush, segmentGPointArray);
            }

            #endregion
            #region Ҽ ׸.

            if(drawDecimalPoint)
            {
                graphics.FillEllipse
                (
                    fillPen.Brush,
                    new RectangleF
                    (
                        position.X + GetX(10F, width),
                        position.Y + GetY(12F, height),
                        width / 7, 
                        width / 7
                    )
                );
            }

            #endregion
        }

        #endregion
        #region  ׸ - DisplayNumber(graphics, number, drawRectangle)

        /// <summary>
        ///  ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="number"></param>
        /// <param name="drawRectangle">׸ 簢</param>
        private void DisplayNumber(Graphics graphics, float number, RectangleF drawRectangle)
        {
            try
            {
                string numberString = number.ToString("000.00");

                numberString.PadLeft(3, '0');

                float shift = 0; 

                if(number < 0)
                {
                    shift -= this.width / 17;
                }

                bool drawDPS = false;

                char[] characterArray = numberString.ToCharArray();

                for(int i = 0; i < characterArray.Length; i++)
                {
                    char character = characterArray[i];

                    if(i < characterArray.Length - 1 && characterArray[i + 1] == '.')
                    {
                        drawDPS = true;
                    }
                    else
                    {
                        drawDPS = false;
                    }

                    if(character != '.')
                    {
                        if(character == '-')
                        {
                            DrawDigit(graphics, -1, new PointF(drawRectangle.X + shift, drawRectangle.Y), drawDPS, drawRectangle.Height);
                        }
                        else
                        {
                            DrawDigit(graphics, Int16.Parse(character.ToString()), new PointF(drawRectangle.X + shift, drawRectangle.Y), drawDPS, drawRectangle.Height);
                        }

                        shift += 15 * this.width / 250;
                    }
                    else
                    {
                        shift += 2 * this.width / 250;
                    }
                }
            }
            catch(Exception)
            {
            }
        }

        #endregion
    }
}